local _, NS = ...

NS.PREFIX_COLOR = "D040D0"
NS.ADDON_NAME="OrganizedPanic"
NS.DB_NAME="OrganizedPanicDB"
NS.ADDON_TITLE="Organized Panic"
NS.CHAT_COMMAND_NAME="op"
NS.CHAT_ALT_COMMAND_NAME="opanic"

NS.LOG_LEVEL = {
  NONE = 0,
  WARN = 1,
  DEBUG = 2,
  TRACE = 3,
  STACK = 4
}

NS.DEFAULTS = {
  profile = {
    flashBorder = true,
    playSound = true,
    sound = "auctionhouse",
    buffSound = "auctionclose",
    borderColor = {r = 0.0, g = 0.0, b = 1.0},
    debug = false,
    warn = false,
    trace = false,
    stack = false,
    loglevel = 0,
    includeSelf = false,
    includeRole = true,
    includeMinorPanics = false,
    autoShowHide = false,
    windowVisible = false,
    standalone = false,
    minimap = {
      hide = false
    }
  }
}

NS.PANIC_SPELLS = {
  -- HEALERS
  [740] = {class = "DRUID", specialization = "Restoration", role = "HEALER", duration = 180, type = "CHANNELED"}, -- tranquility
  [33891] = {class = "DRUID", specialization = "Restoration", talentId = 33891, role = "HEALER", duration = 180, type = "SHIFT", shift_duration = 30, minor = true}, -- Incarnation: Tree of Life
  [323764] = {class = "DRUID", specialization = "Restoration", covenantId = 3, role = "HEALER", duration = 120, type = "INSTANT", minor = true}, -- Convoke The Spirits
  [64843] = {class = "PRIEST", specialization = "Holy", role = "HEALER", duration = 180, type = "CHANNELED"}, -- divine hymn
  [265202] = {class = "PRIEST", specialization = "Holy", role = "HEALER", duration = 720, type = "CAST"}, -- holy word: salvation
  [115310] = {class = "MONK", specialization = "Mistweaver", role = "HEALER", duration = 180, type = "INSTANT"}, -- revival
  [108280] = {class = "SHAMAN", specialization = "Restoration", role = "HEALER", duration = 180, type = "INSTANT"}, -- healing tide totem
  [98008] = {class = "SHAMAN", specialization = "Restoration", role = "HEALER", duration = 180, type = "INSTANT"}, -- spirit link totem
  -- TANKS
  [50334] = {class = "DRUID", specialization = "Guardian", role = "TANK", duration = 180, type = "INSTANT"}, -- berserk
}

NS.TALENT_MODIFICATIONS = {
  {talentId = 197073, spellId = 740, type = "offset", property = "duration", value = -60} -- inner peace reduces tranquility by 60 seconds
}

NS.SPELL_MODIFICATIONS = {
  [2050] = {spellId = 265202, type = "offset", property = "start", value = -30}, -- holy word: serenity reduces holy word: salvation remaining by 30 seconds
  [34861] = {spellId = 265202, type = "offset", property = "start", value = -30}, -- holy word: sanctify reduces holy word: salvation remaining by 30 seconds
}

NS.SOUNDS = {
  ["none"] = {path = nil, name = "None", top = true},
  ["artifact"] = {path = "Interface/AddOns/OrganizedPanic/sounds/artifact.ogg", name = "Artifact"},
  ["azerite"] = {path = "Interface/AddOns/OrganizedPanic/sounds/azerite.ogg", name = "Azerite"},
  ["legendary"] = {id = 63971, name = "Legendary"},
  ["objectivecomplete"] = {id = 26905, name = "Objective Complete"},
  ["auctionhouse"] = {id = 5274, name = "Auction House"},
  ["auctionclose"] = {id = 5275, name = "Auction House Close"},
  ["raidwarning"] = {id = 8959, name = "Raid Warning"},
  ["raidbosswarning"] = {id = 12197, name = "Raid Boss Warning"},
  ["raidbosswhisperwarning"] = {id = 37666, name = "Raid Boss Whisper Warning"},
  ["arrogance"] = {id = 11471, name = "Illidan: Such arrogance"},
  ["givein"] = {id = 11468, name = "Illidan: Give in to your fear"},
  ["legion_chest"] = {path = "Interface/AddOns/OrganizedPanic/sounds/legion_chest.ogg", name = "Legion Chest"}, -- real sound repeats
  ["stormwind_toll"] = {path = "Interface/AddOns/OrganizedPanic/sounds/stormwind_toll.ogg", name = "Stormwind Toll"}, -- real sound repeats
  ["summon_skiff"] = {path = "Interface/AddOns/OrganizedPanic/sounds/summon_skiff.ogg", name = "Summon Skiff"}, -- real sound too quiet
}

NS.TEST_PANIC_SPELLS = {68251, 55344, 70243, 141453, 268634, 133937, 156736, 299381, 205751, 288901, 320844, 17737}
NS.TEST_PANIC_CASTERS = {"Rendle", "Cudgelface", "Sparkledew", "Lillyensthoom", "Khennennthilee", "Timaeron", "Khadgar", "Nat Pagle"}

NS.AURAS = {
  [29166] = {spellId = 29166, duration = 10, type = "INSTANT"}, -- Innervate
  -- [139] = {spellId = 29166, duration = 10, type = "INSTANT"}, -- Not At All Innervate, for testing
  -- [774] = {spellId = 29166, duration = 10, type = "INSTANT"}, -- Not At All Innervate, for testing
}
